// Machine, pseudo op, Register tables

#include <stdio.h>
#include <string.h>
#include "Assm.h"
#include "pot.h"
#include "mot.h"
#include "reg.h"
#include "optable.h"

C_OP_Table::C_OP_Table	()
{
}

C_OP_Table::~C_OP_Table	()
{
//	printf("\nC_OP_Table Destructor.");
}

int C_OP_Table::GetMOTCount()
{
   return sizeof(mot)/sizeof(MOT);
}

MOT * C_OP_Table::GetMOTAt(int idx)
{
	if ( GetMOTCount() < idx )
		return NULL;
	return &mot[idx];
}

int C_OP_Table::GetPOTCount()
{
   return sizeof(pot)/sizeof(POT);
}


POT * C_OP_Table::GetPOTAt(int idx)
{
	if ( GetPOTCount() < idx )
		return NULL;
	return &pot[idx];
}

int C_OP_Table::IsRegister(CString &String)
{
	int w, s;
	return IsRegister(String,w,s);
}

int C_OP_Table::IsRegister(CString &Str, int & wide, int &Seg)
{
	int ret = -1,i,max;
	CString String(Str);
	String.ToUpper();

	if(String[2] != 0 )
	{
		return ret;
	}

	wide = 1;
	Seg = 0;

	max = sizeof(Registers) / sizeof(REG);

	if( String[1]=='L' || String[1]=='H')
		wide = 0;

	for(i=0;i<max;i++)
	{
		if(String.Compare(Registers[i].Reg)==0 )
		{
			ret = Registers[i].code;
			break;
		}
	}
	if(ret != -1 && i > 14 )
		Seg = 1;
	return ret;
}
