#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "String.h"

CString::CString(int count)
{
	string = new char[count];
	Count = count;
	Step = 10;
	string[0] = 0;
}

CString::CString(char *str)
{
	Count = strlen(str) + 1;
	Step = 10;
	string = new char[Count];
	strcpy(string, str);
}

CString::CString(CString &Str)
{
	Count = Str.Count;
	Step = 10;
	string = new char[Count];
	strcpy(string, Str.string);
}

CString::~CString()
{
	delete string;
}

char CString::operator [] (int index)
{
	if(index > Count)
		return -1;
	return string[index];
}

const CString& CString::operator = (char *str)
{
	delete string;
	Count = strlen(str) + 1;
	string = new char[Count];
	strcpy(string, str);
	return *this;
}

CString & CString::operator = (CString & Str)
{
	delete string;
	Count = Str.GetLength() + 1;
	string = new char[Count];
	strcpy(string, Str.string);
	return *this;
}

CString& CString::operator += (CString &str)
{
	char *temp=NULL;
	int i, j , k;
	i=GetLength();
	j=str.GetLength();
	temp =new char[i + j + 1];
	strcpy(temp,string);
	for(k=0;k<=j;k++)
		temp[k+i]=str[k];
	Count=i + j + 1;
	delete string;
	string = temp;
	return *this;
}

CString& CString::operator += (char c)
{
	char *temp=NULL;
	int i;
	i=GetLength();
	if(Count == (i + 1))
	{
		Count += Step;
		temp = new char[Count];
		strcpy(temp,string);
		delete string;
		string=temp;
	}
	string[i]=c;
	string[i+1]=0;
	return *this;
}

CString& CString::operator += (char * str)
{
	char *temp=NULL;
	int i, j , k;
	i=GetLength();
	j=strlen(str);
	temp =new char[i + j + 1];
	strcpy(temp,string);
	for(k=0;k<=j;k++)
		temp[k+i]=str[k];
	Count= i + j + 1 ;
	delete string;
	string = temp;
	return *this;
}

char const * CString::GetPointer()
{
	return (char const * ) string;
}

int CString::GetLength()
{
	return strlen(string);
}

void CString::Print()
{
	printf("%s",string);
}

void CString::Print(char * Format)
{
	printf(Format,string);
}

int CString::SetAt(int index, char c)
{
	if(index >= Count)
	{
		return 0;
	}
	string[index]=c;
	return 1;
}

int CString::SetLength(int len)
{
	if(len < 1)
		return 0;
	CString temp=string;

	delete string;
	string = new char[len];
	Count = len;
	for (int i=0; i<len && temp[i]!=0; i++)
		string[i]=temp[i];
	if(i==len)
		string[i-1]=0;
	else
		string[i]=0;
	return 1;
}

int CString::Empty()
{
	string[0]=0;
	return 1;
}

int CString::IsEmpty()
{
	if( GetLength() == 0)
		return 1;
	else
		return 0;
}

void CString::Trim()
{
	CString Temp;
	int i, max=GetLength();
	//Trimming left
	for(i=0; i < max && (string[i] == ' ' || string[i] == '\t' ); i++);
	Temp = SubString(i);
	//Trimming right
	for(i = Temp.GetLength() - 1 ; i>=0 && ( Temp[i] == ' ' || Temp[i] == '\t' ) ; i--);
	Temp.string[i+1]=0;
	strcpy(string,Temp.string);
}

int CString::IsInteger()
{
	if( string[0] >= '0' && string[0] <= '9' )
		return 1;
	else
		return 0;
}

int CString::ToInteger()
{
	int i, Hex=0, Bin=0, Oct=0, Dec=0;
	int valid = 1, val = 0;
	switch(string[GetLength() -1 ] )
	{
		case 'D':
		case 'd':
			Dec = 1; break;
		case 'H':
		case 'h':
			Hex = 1; break;
		case 'O':
		case 'o':
			Oct = 1; break;
		case 'B':
		case 'b':
			Bin = 1; break;
		default:
			Dec = 1;
	}

	for (i=0;string[i]!=0;i++)
	{
		if(string[i+1]==0 && (
					string[i] == 'D' ||
					string[i] == 'O' ||
					string[i] == 'B' ||
					string[i] == 'H'  ||
					string[i] == 'd' ||
					string[i] == 'o' ||
					string[i] == 'b' ||
					string[i] == 'h')
						 )
			break;

		if( (string[i] =='0' || string[i] =='1') );
		else if( string[i] >='2' && string[i] <='7')
		{
			if(Bin)
			{
				valid = 0;
				break;
			}
		}
		else if( string[i] >='8' && string[i] <='9')
		{
			if(Bin || Oct)
			{
				valid = 0;
				break;
			}
		}
		else if( (string[i] >='A' && string[i]<='F')
					|| (string[i] >='a' && string[i]<='f') )
		{
			if(!Hex)
			{
				valid = 0;
				break;
			}
		}
		else
		{
			valid = 0 ;
			break;
		}
	}
	if( !valid )
		return 0;
	if( Dec )
		sscanf(string,"%d",&val);
	else if ( Hex )
		sscanf(string,"%X",&val);
	else if ( Oct )
		sscanf(string,"%o",&val);
	else if ( Bin )
	{
		for(i=0; string[i]=='1' || string[i]=='0' ; i++ )
			val = ( val * 2 ) + ( string[i] - '0' );
	}
	return val;
}

int CString::Compare(char * str)
{
	return stricmp(str,string);
}

int CString::Compare(CString &str)
{
	return stricmp(str.string,string);
}

int CString::ToUpper()
{
	strupr(string);
	return 1;
}

void CString::CopyTo(char *str)
{
	strcpy(str,string);
}

CString CString::SubString(int Offset)
{
	CString Temp(Count);
	int max=GetLength();
	if(Offset < 0 || Offset >=max)
		return CString();
	strcpy(Temp.string,string+Offset);
	return CString(Temp);
}

FILE * CString::FileOpen(char * mode)
{
	return fopen(string, mode);
}

int CString::WriteFile(FILE * fptr)
{
	return fprintf(fptr,"%s",string);
}

int CString::ReadFile(FILE * fptr)
{
	char c;
	Empty();
	while(1)
	{
		c=fgetc(fptr);
		if(c==EOF)
			return 0;
		if( c=='\n' )
			break;
		*this += c;
	}
	return 1;
}