#include <stdio.h>
#include <conio.h>
#include <string.h>
#include "structur.h"

struct MOT_old
{
	char mne_op[7];
	BYTE  op_code;
	BYTE  ext_op_code;
	BYTE type;
	unsigned Reg_op : 3;
	unsigned Reg_operand : 3;
	unsigned Reg_operand_valid : 1;
	unsigned w : 1;
	unsigned d : 1;
	unsigned s : 1;
	unsigned v : 1;
	unsigned z : 1;
	unsigned Accumulator : 1;
	unsigned SegmentRegister : 1;

} old_rec;

struct MOT rec;

void disprec(struct MOT rec);
void Read(FILE *fptr);

void main()
{
	FILE *fpnew, *fpold;
	fpnew=fopen("NEWMOT.dat","wb");
	fpold=fopen("MOT.DAT","rb");
	printf("\n Size of new %d; old %d",sizeof(rec),sizeof(old_rec) );
	while( fread(&old_rec,sizeof(old_rec),1,fpold) )
	{
		strcpy(rec.mne_op,old_rec.mne_op);
		rec.op_code=old_rec.op_code;
		rec.ext_op_code=old_rec.ext_op_code;
		rec.type=old_rec.type;
		rec.Reg_op=old_rec.Reg_op;
		rec.Reg_operand=old_rec.Reg_operand;
		rec.w=old_rec.w;
		rec.d=old_rec.d;
		rec.s=old_rec.s;
		rec.v=old_rec.v;
		rec.z=old_rec.z;
		rec.Accumulator=old_rec.Accumulator;
		rec.SegmentRegister=old_rec.SegmentRegister;
		rec.Reg_operand_valid = old_rec.Reg_operand_valid;
		rec.FarCall = 0;

		fwrite(&rec,sizeof(rec),1,fpnew);
	}

	fclose(fpold);
	fclose(fpnew);
	printf("\nMOT.DAT -> NEWMOT.DAT");
	fpnew=fopen("NEWMOT.DAT","rb");
	Read(fpnew);
	unlink("MOT.dat");
	rename("newmot.dat","mot.dat");
}

void Read(FILE *fptr)
{
	long count=0;
	struct MOT rec;
	fseek(fptr,0,SEEK_SET);
	printf("\n<Mnemonic op code> <Binary op code> <Type> < w d s v z Reg1 Reg2 Seg AX Lop Far>");
	while(fread(&rec,sizeof(rec),1,fptr))
	{
		count++;
		if(count%24 == 0)
		{
			printf("\nPress any key to continue...");
			getch();
			fflush(stdin);
		}
		disprec(rec);
	}
	printf("\nTotal records %d",count);
}

void disprec(struct MOT rec)
{
	printf("\n\t%s\t\t0x%X\t\t%d",rec.mne_op,rec.op_code,rec.type);
	printf("    %d %d %d %d %d",rec.w, rec.d, rec.s, rec.v, rec.z);
	printf("  %d    %d    %d   %d   0x%X",rec.Reg_op,rec.Reg_operand,rec.SegmentRegister, rec.Accumulator, rec.ext_op_code);
	printf(" %d",rec.FarCall);
}

